Sign in Start for free

Worker Pools

Get a list of Worker Pools

GET /api/{spaceId}/workerpools

Also reachable at /api/spaces/{spaceIdentifier}/workerpools, /api/workerpools.

Lists the name and ID of of the Worker Pools in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each Worker Pool.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • ids array of string
    List of Worker Pool IDs which if specified, filters the result to only include Worker Pools with matching IDs.
  • name string
    The exact name of a Worker Pool to be matched.
  • partialName string
    A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 10. Minimum 0.

Response

200 — The requested list of Worker Pools

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • CanAddWorkers boolean
    • Description string
      Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.
    • Id string
      Gets or sets a unique identifier for this resource.
    • IsDefault boolean
      Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Name string
      Gets or sets the name of this pool. This should be short, preferably 5-20 characters.
    • Slug string
    • SortOrder integer
      Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.
    • SpaceId string
    • WorkerPoolType enum
      Allowed values: StaticWorkerPool, DynamicWorkerPool.
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "CanAddWorkers": true,
      "Description": "string",
      "Id": "string",
      "IsDefault": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Name": "string",
      "Slug": "string",
      "SortOrder": 0,
      "SpaceId": "string",
      "WorkerPoolType": "StaticWorkerPool"
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Create a new Worker Pool

POST /api/{spaceId}/workerpools

Also reachable at /api/spaces/{spaceIdentifier}/workerpools, /api/workerpools.

Path Parameters

  • spaceId string (required)

Request Body

  • Description string
    Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.
  • IsDefault boolean
    Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.
  • Name string (required)
    Gets or sets the name of this pool. This should be short, preferably 5-20 characters. Minimum length 1.
  • Slug string
  • SortOrder integer
    Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.
  • SpaceId string (required)
  • WorkerPoolType enum (required)
    Allowed values: StaticWorkerPool, DynamicWorkerPool.
  • WorkerType string

Response

201 — Created

  • CanAddWorkers boolean
  • Description string
    Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDefault boolean
    Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this pool. This should be short, preferably 5-20 characters.
  • Slug string
  • SortOrder integer
    Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.
  • SpaceId string
  • WorkerPoolType enum
    Allowed values: StaticWorkerPool, DynamicWorkerPool.

Example Request

JSON
{
  "Description": "string",
  "IsDefault": true,
  "Name": "string",
  "Slug": "string",
  "SortOrder": 0,
  "SpaceId": "string",
  "WorkerPoolType": "StaticWorkerPool",
  "WorkerType": "string"
}

Example Response

JSON
{
  "CanAddWorkers": true,
  "Description": "string",
  "Id": "string",
  "IsDefault": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Name": "string",
  "Slug": "string",
  "SortOrder": 0,
  "SpaceId": "string",
  "WorkerPoolType": "StaticWorkerPool"
}

Get a list of Worker Pools

GET /api/{spaceId}/workerpools/all

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/all, /api/workerpools/all.

Lists the name and ID of of the Worker Pools in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each Worker Pool.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • ids array of string
    List of Worker Pool IDs which if specified, filters the result to only include Worker Pools with matching IDs.

Response

200 — The list of requested Worker Pools

  • CanAddWorkers boolean
  • Description string
    Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDefault boolean
    Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this pool. This should be short, preferably 5-20 characters.
  • Slug string
  • SortOrder integer
    Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.
  • SpaceId string
  • WorkerPoolType enum
    Allowed values: StaticWorkerPool, DynamicWorkerPool.

Example Response

JSON
[
  {
    "CanAddWorkers": true,
    "Description": "string",
    "Id": "string",
    "IsDefault": true,
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "Name": "string",
    "Slug": "string",
    "SortOrder": 0,
    "SpaceId": "string",
    "WorkerPoolType": "StaticWorkerPool"
  }
]

List the available Worker Types for the Dynamic Worker Pool

GET /api/{spaceId}/workerpools/dynamicworkertypes

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/dynamicworkertypes, /api/workerpools/dynamicworkertypes.

Returns a list of the available Worker Types for the Dynamic Worker Pool

Path Parameters

  • spaceId string (required)

Response

200 — The requested Dynamic Worker Types

  • Id string
  • Links object
  • WorkerTypes array of object
    • DeprecationDateUtc string
      Format date-time.
    • Description string
    • EndOfLifeDateUtc string
      Format date-time.
    • Id string
    • StartDateUtc string
      Format date-time.
    • Type string

Error Responses

  • 500 internal_server_error — Unable to connect to the Dynamic Worker service

Example Response

JSON
{
  "Id": "string",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "WorkerTypes": [
    {
      "DeprecationDateUtc": "2020-01-01T00:00:00.000Z",
      "Description": "string",
      "EndOfLifeDateUtc": "2020-01-01T00:00:00.000Z",
      "Id": "string",
      "StartDateUtc": "2020-01-01T00:00:00.000Z",
      "Type": "string"
    }
  ]
}

PUT /api/{spaceId}/workerpools/sortorder

PUT /api/{spaceId}/workerpools/sortorder

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/sortorder, /api/workerpools/sortorder.

Takes an array of work pool IDs as the request body, uses the order of items in the array to sort the worker pools on the server. The ID of every worker pool must be specified.

Path Parameters

  • spaceId string (required)

Request Body

A array of string payload.

Response

200 — Success

Example Request

JSON
[
  "string"
]

List all worker pools, including a summary of worker information

GET /api/{spaceId}/workerpools/summary

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/summary, /api/workerpools/summary.

Lists all worker pools, including a summary of machine information.

Path Parameters

  • spaceId string (required)

Query Parameters

  • commStyles array of string
  • healthStatuses array of string
  • hideEmptyWorkerPools boolean
  • ids array of string
  • isDisabled boolean
  • machinePartialName string
  • partialName string
  • shellNames array of string

Response

200 — The requested Worker Pool Summary

  • MachineEndpointSummaries object
  • MachineHealthStatusSummaries object
  • MachineIdsForCalamariUpgrade array of string
  • MachineIdsForTentacleUpgrade array of string
  • TentacleUpgradesRequired boolean
  • TotalDisabledMachines integer
  • TotalMachines integer
  • WorkerPoolSummaries array of object
    • MachineEndpointSummaries object
    • MachineHealthStatusSummaries object
    • MachineIdsForCalamariUpgrade array of string
    • MachineIdsForTentacleUpgrade array of string
    • TentacleUpgradesRequired boolean
    • TotalDisabledMachines integer
    • TotalMachines integer
    • WorkerPool object

Example Response

JSON
{
  "MachineEndpointSummaries": {
    "additionalProp1": 0,
    "additionalProp2": 0,
    "additionalProp3": 0
  },
  "MachineHealthStatusSummaries": {
    "additionalProp1": 0,
    "additionalProp2": 0,
    "additionalProp3": 0
  },
  "MachineIdsForCalamariUpgrade": [
    "string"
  ],
  "MachineIdsForTentacleUpgrade": [
    "string"
  ],
  "TentacleUpgradesRequired": true,
  "TotalDisabledMachines": 0,
  "TotalMachines": 0,
  "WorkerPoolSummaries": [
    {
      "MachineEndpointSummaries": {
        "additionalProp1": 0,
        "additionalProp2": 0,
        "additionalProp3": 0
      },
      "MachineHealthStatusSummaries": {
        "additionalProp1": 0,
        "additionalProp2": 0,
        "additionalProp3": 0
      },
      "MachineIdsForCalamariUpgrade": [
        "string"
      ],
      "MachineIdsForTentacleUpgrade": [
        "string"
      ],
      "TentacleUpgradesRequired": true,
      "TotalDisabledMachines": 0,
      "TotalMachines": 0,
      "WorkerPool": {
        "CanAddWorkers": true,
        "Description": "string",
        "Id": "string",
        "IsDefault": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "Name": "string",
        "Slug": "string",
        "SortOrder": 0,
        "SpaceId": "string",
        "WorkerPoolType": "StaticWorkerPool"
      }
    }
  ]
}

Get the available Worker Pool types

GET /api/{spaceId}/workerpools/supportedtypes

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/supportedtypes, /api/workerpools/supportedtypes.

Lists the available Worker Pool types.

Path Parameters

  • spaceId string (required)

Response

200 — The list of Supported Worker Pool Types

  • Id string
  • Links object
  • SupportedPoolTypes array of enum
    Allowed values: StaticWorkerPool, DynamicWorkerPool.

Example Response

JSON
{
  "Id": "string",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "SupportedPoolTypes": [
    "StaticWorkerPool"
  ]
}

Get a Worker Pool by ID

GET /api/{spaceId}/workerpools/{id}

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/{id}, /api/workerpools/{id}.

Path Parameters

  • id string (required)
  • spaceId string (required)

Response

200 — The requested Worker Pool.

  • CanAddWorkers boolean
  • Description string
    Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDefault boolean
    Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this pool. This should be short, preferably 5-20 characters.
  • Slug string
  • SortOrder integer
    Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.
  • SpaceId string
  • WorkerPoolType enum
    Allowed values: StaticWorkerPool, DynamicWorkerPool.

Example Response

JSON
{
  "CanAddWorkers": true,
  "Description": "string",
  "Id": "string",
  "IsDefault": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Name": "string",
  "Slug": "string",
  "SortOrder": 0,
  "SpaceId": "string",
  "WorkerPoolType": "StaticWorkerPool"
}

Modify an existing worker pool

PUT /api/{spaceId}/workerpools/{id}

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/{id}, /api/workerpools/{id}.

Updates an existing worker pool.

Path Parameters

  • id string (required)
    The ID of the worker pool.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • Description string
    The description of the worker pool.
  • Id string (required)
    The ID of the worker pool.
  • IsDefault boolean (required)
    Whether the worker pool is the default or not.
  • Name string (required)
    The name of the worker pool. Minimum length 1.
  • Slug string
    The slug of the worker pool.
  • SpaceId string (required)
    The ID of the space containing the resource(s).
  • WorkerType string
    The worker image.

Response

200 — Confirms that a Worker Pool was modified, containing the updated Worker Pool

  • CanAddWorkers boolean
  • Description string
    Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDefault boolean
    Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this pool. This should be short, preferably 5-20 characters.
  • Slug string
  • SortOrder integer
    Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.
  • SpaceId string
  • WorkerPoolType enum
    Allowed values: StaticWorkerPool, DynamicWorkerPool.

Example Request

JSON
{
  "Description": "string",
  "Id": "string",
  "IsDefault": true,
  "Name": "string",
  "Slug": "string",
  "SpaceId": "string",
  "WorkerType": "string"
}

Example Response

JSON
{
  "CanAddWorkers": true,
  "Description": "string",
  "Id": "string",
  "IsDefault": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Name": "string",
  "Slug": "string",
  "SortOrder": 0,
  "SpaceId": "string",
  "WorkerPoolType": "StaticWorkerPool"
}

Delete an existing Worker Pool

DELETE /api/{spaceId}/workerpools/{id}

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/{id}, /api/workerpools/{id}.

Path Parameters

  • id string (required)
    ID of the Worker Pool to delete.
  • spaceId string (required)

Response

200 — Success

Get a list of WorkerResources for the given WorkerPoolResource

GET /api/{spaceId}/workerpools/{id}/workers

Also reachable at /api/spaces/{spaceIdentifier}/workerpools/{id}/workers, /api/workerpools/{id}/workers.

Lists all of the machines that belong to the given worker pool.

Path Parameters

  • id string (required)
    ID of the WorkerPool.
  • spaceId string (required)

Query Parameters

  • commStyles array of string
  • deploymentTargetTypes array of string
  • healthStatuses array of string
  • isDisabled boolean
  • operatingSystemNames array of string
  • partialName string
  • shellNames array of string
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 20. Minimum 0.

Response

200 — The requested list of Workers within a Worker Pool

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Architecture string
    • Endpoint object
    • HasLatestCalamari boolean
    • HealthStatus enum
      Allowed values: Healthy, Unavailable, Unknown, HasWarnings, Unhealthy.
    • Id string
      Gets or sets a unique identifier for this resource.
    • IsDisabled boolean
    • IsInProcess boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • MachinePolicyId string
    • Name string
    • OperatingSystem string
    • OperatingSystemVersion string
    • ShellName string
    • ShellVersion string
    • SkipInitialHealthCheck boolean
    • Slug string
    • SpaceId string
    • StatusSummary string
    • Thumbprint string
    • Uri string
    • WorkerPoolIds array of string
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Architecture": "string",
      "Endpoint": {
        "CommunicationStyle": "None",
        "Id": "string",
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {}
      },
      "HasLatestCalamari": true,
      "HealthStatus": "Healthy",
      "Id": "string",
      "IsDisabled": true,
      "IsInProcess": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "MachinePolicyId": "string",
      "Name": "string",
      "OperatingSystem": "string",
      "OperatingSystemVersion": "string",
      "ShellName": "string",
      "ShellVersion": "string",
      "SkipInitialHealthCheck": true,
      "Slug": "string",
      "SpaceId": "string",
      "StatusSummary": "string",
      "Thumbprint": "string",
      "Uri": "string",
      "WorkerPoolIds": [
        "string"
      ]
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}